; Patch by Conn
; apply on Super Street fighter 2 - The New Challengers (E) without header

; header ; remove selicon before "header" if your rom has a header
hirom

org $C00005
jsl boot

org $C00B7A    ; native hook to induce track change
JSL msuRoutine ; there is no free space in rom, these are ascii credits overwritten which are not used
NOP

org $C00E48    ; mute spc in case new track s introduced
JSL pause

org $C0019A
JSL nmi

org $FFEC00
msuRoutine:
STA $1D75
LDY #$Fa
PHA
LDA $2002      ;check if msu found
CMP #$53               
BEQ msufound
PLA   
RTL            ; spc is played
msufound:
LDA $1D75
cmp $7fe000
beq endNo
STZ $2006      ; mute old track
LDA $1D75
STA $7fe000
STA $2004   ; save track
STZ $2005
LDA #$00
STA $7fe004
msuready:
Bit $2000
bvs msuready ; check if msu is ready
PHX
LDA $1D75
TAX
LDA $ffee00,x ;load loop value
sta $2007  
PLX
lda #$FF   ; volume
sta $2006
sta $7fe002
lda $2000
AND #$08
BNE playspc ; error bit set? 
endNo:
PLA
LDY #$F9 ;mute SPC
RTL
playspc:
PLA
RTL



pause:
INY
STY $1D6b
PHA
LDA $2002      ;check if msu found
CMP #$53   
BEQ continue   
PLA
RTL            ; spc is played
continue:  ; mute track when in PAUSE modus
PLA
CMP #$F6    ; end of battle 
bne $03
jmp fadef6
CMP #$01   ; prevent double spc play in menu/options
bne noend
LDA $1D75
CMP #$40
BNE noend2
lda $2000
AND #$08
BNE $04
lda #$F6
bra $02
noend2:
lda #$01
noend:
CMP #$F0   ; mute start
bne $03
jmp fadef0
CMP #$FB   ; prevent double spc play in menu/options
bne $03
jmp fadefb
CMP #$F3   ; pause start
bne $03
stz $2007
CMP #$F7    ; begin of battle
bne check
PHA
PHX
LDA $1D75
TAX
LDA $ffee00,x ;load loop value
STA $2007  ; also wenn ein theme endlos looped dann mach hier eine 03 auf 2007
PLX
PLA
check:
CMP #$F4   ; end pause
bne end
PHA
PHX
LDA $1D75
TAX
LDA $ffee00,x ;load loop value
STA $2007  ; also wenn ein theme endlos looped dann mach hier eine 03 auf 2007
PLX
PLA
end:
RTL


fadef6:
pha
LDA $1D75
CMP #$2a
beq zero
lda $05d0
cmp #$02
beq zero
lda $0810
cmp #$02
beq zero
lda #$01
sta $7fe004
pla
RTL
zero:
lda #$02
sta $7fe004
pla
RTL

fadefb:
pha
LDA $1D75
CMP #$2a
bne $02
pla
RTL
lda $05d0
cmp #$00
bne endfb
lda $0810
cmp #$00
bne endfb
LDA $087A
CMP $0531
BEQ endfb
LDA $7e1915
CMP #$00
BNE endfb
stz $2007
stz $1D75
pla
RTL
endfb:
lda #$03
sta $7fe004
pla
lda #$f0
RTL

fadef0:
pha
LDA $1D75
CMP #$2a
bne $02
pla
RTL
cmp #$22
beq resetTheme
lda $05d0
cmp #$00
bne endf0
lda $0810
cmp #$00
bne endf0
LDA $087A
CMP $0531
BEQ endf0
LDA $7e1915
CMP #$00
BNE endf0
BRA $09
resetTheme:
LDA #$00
STA $7fe000
STZ $1D7F
stz $1D75
stz $2007
pla
RTL
endf0:
pla
RTL

nmi:
SEP #$30
LDA $7fe004
bne $03
LDA #$87
RTL
cmp #$01
beq fadehalf
cmp #$02
beq fadezero
lda $7fe002
cmp #$FF
beq endup
inc
inc
cmp #$fb
bcc fu
endup:
LDA #$00
sta $7fe004
lda #$FF
fu:
sta $2006
sta $7fe002
LDA #$87
RTL

fadezero:
lda $7fe002
cmp #$00
beq endzero
lda $7fe002
dec
dec
cmp #$10
bcs fz
endzero:
lda #$00
sta $7fe004
fz:
sta $2006
sta $7fe002
LDA #$87
RTL

fadehalf:
lda $7fe002
cmp #$40
beq endhalf
dec
dec
cmp #$40
bcs fh
endhalf:
lda #$00
sta $7fe004
lda #$40
fh:
sta $2006
sta $7fe002
LDA #$87
RTL

boot:
LDY #$00
REP #$10
LDA #$00
STA $7fe000
STA $7fe002
STA $7fe004
RTL


ORG $ffee00 ; loop table 03:loop, 01 non-loop
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f 
db $01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 10-1f
db $03,$03,$01,$03,$01,$01,$03,$01,$01,$01,$03,$01,$03,$01,$01,$01 ; themes 20-2f
db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; themes 30-3f 
db $01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 40-4f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 50-4f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 60-6f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 70-7f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 80-8f 	